<script setup>
import { computed, ref } from 'vue';
import Upgrades from '../panes/upgrades.vue';
import Profile from 'modules/profile';
import Settings from 'modules/settings';
import { locked } from '../itemsBase';
import { useHidable } from '../composables/use-hidable';

const props = defineProps(['state']);

const ops = Settings.getSubVars('main');
if (!ops.hide) ops.hide = {}

const hide = ref(ops.hide);
const elRef = ref();
const btnHide = ref();
const { inConfig, hides, canShow } = useHidable(btnHide, elRef);

const mergedtasks = computed(() => { return props.state.tasks.concat(Profile.hall.tasks) });

const tasks = computed(() => {
	return mergedtasks.value.filter(v => (!v.perpetual || v.perpetual == 0) && (!v.length || v.length == 0))
});

const runnables = computed(() => {
	return mergedtasks.value.filter(v => (v.perpetual > 0 || v.length > 0) && !v.craftable && !v.morality)
});

const crafts = computed(() => { return mergedtasks.value.filter(v => (v.perpetual > 0 || v.length > 0) && v.craftable && (v.value < v.max || !v.max) && v.locked == false) });

const morals = computed(() => { return mergedtasks.value.filter(v => v.value < 1 && !v.craftable && v.morality && !v.disabled && v.locked == false) });

const visActs = computed(() => { return tasks.value.filter(v => canShow(v)) });
const visRuns = computed(() => { return runnables.value.filter(v => canShow(v)) });
const visCrafts = computed(() => { return crafts.value.filter(v => canShow(v)) });
const visMorals = computed(() => { return morals.value.filter(v => canShow(v)) });

const upgrades = computed(() => {
	return props.state.upgrades.filter(v => !locked(v) && canShow(v))
});
const classes = computed(() => {
	return props.state.classes.filter(v => !locked(v) && canShow(v));
});

</script>

<template>
	<div class="main-tasks" ref="elRef">
		<div class="config"><button ref="btnHide" class="btnConfig"></button></div>
		<div v-if="visActs.length != 0" class="div-hs">Actions</div>
		<Upgrades class="task-list" :items="visActs" :preventClick="inConfig" />
		<div v-if="visRuns.length != 0" class="div-hs">Tasks</div>
		<Upgrades class="task-list" :items="visRuns" :preventClick="inConfig" />
		<div v-if="upgrades.length != 0" class="div-hs">Upgrades</div>
		<Upgrades class="upgrade-list" :items="upgrades" :preventClick="inConfig" />
		<div v-if="classes.length != 0" class="div-hs">Classes</div>
		<Upgrades class="upgrade-list" :items="classes" :preventClick="inConfig" />
		<div v-if="visCrafts.length != 0" class="div-hs">Craftables</div>
		<Upgrades class="upgrade-list" :items="visCrafts" :preventClick="inConfig" />
		<div v-if="visMorals.length != 0" class="div-hs">Morality Options</div>
		<Upgrades class="upgrade-list" :items="visMorals" :preventClick="inConfig" />
	</div>
</template>

<style scoped>
div.task-list,
.main-tasks>div.upgrade-list {
	margin: 0;
	padding: var(--md-gap);
	display: grid;
	grid-template-columns: repeat(auto-fit, var(--task-button-width));
}

div.upgrade-list:empty {
	padding: 0px;
}

div.task-list .runnable:hover {
	background: var(--accent-color-hover);
}

div.task-list .runnable:active {
	background: var(--accent-color-active);
}
</style>
